%global _description %{expand:
cattrs is an open source Python library for structuring and
unstructuring data. cattrs works best with attrs classes and the usual
Python collections, but other kinds of classes are supported by
manually registering converters.}

%bcond_with cbor2
%bcond_with bson
%bcond_with tests

Summary:        Python library for structuring and unstructuring data
Name:           python-cattrs
Version:        23.2.3
Release:        1%{?dist}
License:        MIT
URL:            https://github.com/python-attrs/cattrs
Source0:        %{url}/archive/v%{version}/cattrs-%{version}.tar.gz

BuildRequires:  python3-devel
BuildArch:      noarch

%if %{with tests}
BuildRequires:  %{py3_dist hypothesis}
BuildRequires:  %{py3_dist pytest}
BuildRequires:  %{py3_dist immutables}
BuildRequires:  %{py3_dist typing-extensions}
BuildRequires:  %{py3_dist pytest-xdist}
%endif

%description %_description

%package -n python3-cattrs
Summary:        Python library for structuring and unstructuring data

%description -n python3-cattrs %_description

%package        doc
Summary:        Documentation for python-cattrs

%description    doc %{_description}

%prep
%autosetup -n cattrs-%{version}
sed -r -i 's/"(coverage)\b/# &/' pyproject.toml
sed -r -i 's/"(pytest-benchmark)\b/# &/' pyproject.toml
sed -r -i 's/ --benchmark[^[:blank:]"]*//g' pyproject.toml
sed -r -i 's/^(version = ).*/\1 "%{version}"/' docs/conf.py

%generate_buildrequires
export SETUPTOOLS_SCM_PRETEND_VERSION='%{version}'
%pyproject_buildrequires -x ujson,orjson,msgpack,pyyaml,tomlkit%{?with_cbor2:,cbor2}%{?with_bson:,bson}

%build
export SETUPTOOLS_SCM_PRETEND_VERSION='%{version}'
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files cattrs cattr

%check
%if %{with tests}
%if %{without cbor2}
ignore="${ignore-} --ignore=tests/test_preconf.py"
%endif
%pytest --ignore-glob='bench/*' ${ignore-} -k "${k-}" -n auto
%endif

%files -n python3-cattrs -f %{pyproject_files}


%files doc
%license LICENSE
%doc HISTORY.md
%doc README.md

%changelog
* Thu Jun 13 2024 Shuo Wang <abushwang@tencent.com> - 23.2.3-1
- initial build
